#!/usr/bin/env python
# Created: Chandra Sekhar Pedamallu, DFCI
# Purpose: mapper jobs
# Notes: S3 bucket is not available for this version
# DFCI @ copyright

import sys
import os
import commands
import random

#input comes from STDIN
for line in sys.stdin:
        # Strip off spaces infornt and behing the lines
        line = line.strip()
        print line
        tokens=line.split("/")
        name=""
        for token in tokens:
                name=token
        print name

        # Wget the SAM files from FTP server
        wget1="/usr/bin/wget -nd -P /mnt/mfiles/reads/ " + line
        wget=commands.getstatusoutput(wget1)
        print wget
        print "\n"

        #File names
        fFASTQ=name
        fSAM=name + ".sam"
	fQSAM=fSAM + ".sam"
        fFQ1=name + ".fq1"
        fBFQ=name + ".bfq"
        fUmap=name + ".nr"
        fOut=name + ".out"
  
	fDUP1=name + ".dup"
        fDUP=fDUP1 + ".fq1"

	fSORT1=name + ".sorted"
	fSORT=fSORT1 + ".fq1"
	
	fFASTA=name + ".fasta"



        #Convert FASTQ 2 FQone - Compile Java file
        pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        pp1f1=pp1f1 + "Fastq2FQone.java"
        p1f2=commands.getstatusoutput(pp1f1)
        print pp1f1

        # Convert FASTQ 2 FQone
        SAM2FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . Fastq2FQone /mnt/mfiles/reads/" + fFASTQ
        SAM2FASTQ=SAM2FASTQ + " /mnt/mfiles/reads/"
        SAM2FASTQ=SAM2FASTQ + fFQ1
        p6=commands.getstatusoutput(SAM2FASTQ);
        print p6

        #Step 3a: Duplicate remover
	# Sort
        SORT1="/bin/sort +1 -2 /mnt/mfiles/reads/" + fFQ1
	SORT1=SORT1 + " > /mnt/mfiles/reads/"
	SORT1=SORT1 + fSORT
        p6=commands.getstatusoutput(SORT1);
        print p6

	QUAL1="/usr/bin/g++ duplicateremover.cc -o duplicateremover"
        p6=commands.getstatusoutput(QUAL1);
        print p6
	
	QUAL1="./duplicateremover /mnt/mfiles/reads/" + fSORT 
	QUAL1=QUAL1 + " 1 /mnt/mfiles/reads/"
        QUAL1=QUAL1 + fFQ1
        print QUAL1
        p6=commands.getstatusoutput(QUAL1);
        print p6

	# remove temporaryfiles from duplicate remover
	RM1="/bin/rm -f /mnt/mfiles/reads/" + fSORT
        p6=commands.getstatusoutput(RM1);
        print p6


        #Convert RepeatMaskerFormat - Compile Java file
        pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        pp1f1=pp1f1 + "RepeatMaskerFormat.java"
        p1f2=commands.getstatusoutput(pp1f1)
        print pp1f1

        #Run RepeatMaskerFormat
        pp1f1="/usr/local/jdk1.6.0_21/bin/java -classpath . "
        pp1f1=pp1f1 + "RepeatMaskerFormat "
        pp1f1=pp1f1 + "/mnt/mfiles/reads/"
        pp1f1=pp1f1 + fFQ1
        pp1f1=pp1f1 + " /mnt/mfiles/reads/"
	pp1f1=pp1f1 + fFASTA
	pp1f1=pp1f1 + " FQ1"
        p1f2=commands.getstatusoutput(pp1f1)
        print pp1f1


	# Run Repetmasker
	
	
