/*
 * Updated : Chandra Sekhar Pedamallu
 * Date :07-01-10 
 * Author: Aleksandar D. Kostic
 * Date: 10-16-09
 * Usage: contains methods for FileSplitter.java
 * Details: Splits a file into multiple files.
 * Details : Splits files and also creates manifest files using S3 bucket information
 * NONE option only works here
 */


import java.io.*;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class SplitFiles_S3bucket

{
	FileReader fr1;
	BufferedReader br;
	String strLine;

	int len;
	int splitlen;
	String str;
	String chosenFileName;
	int makeNewDir= 0;
	String S3Buck;

	long numberOfLines= 0;
	int numberOfFiles;

	SplitFiles_S3bucket(String fileName,int splitlength, String outFileName, int makedir, String S3)
	{
		try
		{
			fr1=new FileReader(fileName);
			br =new BufferedReader(fr1);
			str=fileName;
			len=0;
			splitlen=splitlength;
			chosenFileName= outFileName;
			makeNewDir= makedir;
			S3Buck=S3;
			Split();

		}
		catch(FileNotFoundException e)
		{
			System.out.println("File not found.");
		}

	}
	void Split()
	{

		try
		{
			numberOfFiles=0;
			String overflow= "arbitrary";
			boolean overflowLine= false;
			int thisSplitLen= splitlen;
			if ( makeNewDir == 3 )
				(new File(str+"_spt")).mkdir();
			while( (strLine = br.readLine()) != null )
			{
				String fileName;
				String fileNameMan=null; // File name of Manifest
				if ( makeNewDir == 1 ) {
					(new File(str+"_"+(numberOfFiles+1)+"_spt")).mkdir();
					fileName= str+"_"+(numberOfFiles+1)+"_spt/"+chosenFileName;
				} else if ( makeNewDir == 2 ) {
					fileName= str+"_"+(numberOfFiles+1)+"_"+chosenFileName;
					

					fileNameMan= str+"_"+(numberOfFiles+1)+"_"+chosenFileName+".man"; // Manifest file name
				} else if ( makeNewDir == 3 ) {
					fileName= str+"_spt/"+str+"_"+(numberOfFiles+1)+"_"+chosenFileName;
				} else
					throw new IllegalArgumentException("Must specify whether to create new directories or not.");
				//System.out.println(fileName);
				//System.out.println(fileNameMan);
			
	
		//S3Bucket Infomation	
				StringTokenizer stl = new StringTokenizer(fileName, "/");
				String lsToken=null;
				while(stl.hasMoreTokens()){
					lsToken=stl.nextToken().toString();
				}	
				FileWriter outstream1 = new FileWriter( fileNameMan );
				BufferedWriter out1 = new BufferedWriter(outstream1);
				String manInfo="S3://"+S3Buck+"/"+lsToken;
				out1.write(manInfo);
				out1.close();
		// S3Bucket Information

				BufferedWriter out = new BufferedWriter(new FileWriter(fileName));

				if ( !overflow.equals("arbitrary") ) {
					out.write(overflow + "\n");
					overflowLine= true;
				}
				if (overflowLine)
					thisSplitLen = splitlen-2;
				else
					thisSplitLen = splitlen-1;
				numberOfLines++;
				out.write(strLine + "\n");
				while ( (strLine = br.readLine()) != null && len<thisSplitLen )
				{
					numberOfLines++;
					out.write(strLine + "\n");
					len++;
				}
				if ( len == thisSplitLen ) {
					numberOfLines++;
					overflow = strLine;
				}
				len=0;
				out.flush();
				out.close();
				numberOfFiles++;
			}
			fr1.close();
		}
		
		catch(Exception e)
		{
			System.out.println("gg");
			e.printStackTrace();
		}
	}

	public long getNumLines() {
		return numberOfLines;
	}

	public int getNumFiles() {
		return numberOfFiles;
	}



}
